import { NgModule } from '@angular/core';
import { FormattingModule } from '@app/core/formatting.module';
import { RichTextEditorModule } from '@app/library/rich-text-editor/rich-text-editor.module';
import { CommonFormsModule } from '@common/forms/common-forms.module';
import { ConfirmationDialogModule } from '@common/modules/confirmation-dialog/confirmation-dialog.module';
import { CommonUiModule } from '@common/ui/common-ui.module';
import { DmpEditorComponent } from './dmp-editor.component';
import { DmpEditorRoutingModule } from './dmp-editor.routing';
import { AutoCompleteModule } from '@app/library/auto-complete/auto-complete.module';
import { ReferenceFieldModule } from '@app/ui/reference/reference-field/reference-field.module';
import { DragDropModule } from '@angular/cdk/drag-drop';
import { UserFieldModule } from '../user-field/user-field.module';

@NgModule({
	imports: [
		CommonUiModule,
		CommonFormsModule,
		FormattingModule,
		ConfirmationDialogModule,
		DmpEditorRoutingModule,
		RichTextEditorModule,
		AutoCompleteModule,
		ReferenceFieldModule,
		DragDropModule,
		UserFieldModule
	],
	declarations: [
		DmpEditorComponent,
	],
	exports: [
	],
	providers: [
	]
})
export class DmpEditorModule { }
